﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static PseudonymizaceDat.PrehledZadatelu;

namespace PseudonymizaceDat
{
    public partial class DatovyFormular : Form
    {
        public DatovyFormular()
        {
            // Inicializace komponent formuláře
            InitializeComponent();

            // Nastavení datum v dtpDatumNarozeni
            dtpDatumNarozeni.Value = new DateTime(1960, 1, 1);

            // zaškrtnutí všech radio buttonů defaultně na Ne
            rbtVyuzivateSluzebCharityNe.Checked = true;
            rbtPlneSobestacnyNe.Checked = true;
            rbtPohybovePotizeNe.Checked = true;
            rbtJineZdravotniPotizeNe.Checked = true;
            rbtProhlaseniNe.Checked = true;

            // Nahrání údajů z databáze
            txbJmeno.Text = DataUpravit.Jmeno;
            txbPrijmeni.Text = DataUpravit.Prijmeni;
            txbRodneCislo.Text = DataUpravit.RodneCislo;
            txbMistoNarozeni.Text = DataUpravit.MistoNarozeni;
            dtpDatumNarozeni.Text = DataUpravit.DatumNarozeni;
            
            txbAbsolvovanaZamestnani.Text = DataUpravit.AbsolvovanaZamestnani;
            txbRodinnyStav.Text = DataUpravit.RodinnyStav;
            txbTelCislo.Text = DataUpravit.TelCislo;
            txbVzdelani.Text = DataUpravit.Vzdelani;
            
            txbKontaktniOsobaJmeno.Text = DataUpravit.KontaktniOsobaJmeno;
            txbKontaktniOsobaPrijmeni.Text = DataUpravit.KontaktniOsobaPrijmeni;
            txbKontaktniOsobaTelCislo.Text = DataUpravit.KontaktniOsobaTelCislo;
           
            txaPoznamka.Text = DataUpravit.Poznamka;

            // Pokud data z databáze nejsou prázdná
            if (DataUpravit.Jmeno != null)
            {
                if (DataUpravit.PlneSobestacnyText == "Ano")
                {
                    rbtPlneSobestacnyAno.Checked = true;
                }
                else
                {
                    rbtPlneSobestacnyNe.Checked = true;
                }
                if (DataUpravit.PohybovePotizeText == "Ano")
                {
                    rbtPohybovePotizeAno.Checked = true;
                }
                else
                {
                    rbtPohybovePotizeNe.Checked = true;
                }
                if (DataUpravit.VyuzivatSluzebCharityText == "Ano")
                {
                    rbtVyuzivateSluzebCharityAno.Checked = true;
                }
                else
                {
                    rbtVyuzivateSluzebCharityNe.Checked = true;
                }
                if (DataUpravit.JineZdravotniPotize == "0")
                {

                }
                else
                {
                    rbtJineZdravotniPotizeAno.Checked = true;
                    txaJineZdravotniPotize.Text = DataUpravit.JineZdravotniPotize;
                }
                if (DataUpravit.Prohlaseni == "1")
                {
                    rbtProhlaseniAno.Checked = true;
                }
                else
                {
                    rbtProhlaseniNe.Checked = true;
                }

                // Změna textu tlačítka na upravit
                btnOdeslat.Text = "Upravit";
            }
        }

        // Po kliknutí na tlačítko Odeslat se provede kontrola údajů a zavolají se procedury
        private void btnOdeslat_Click(object sender, EventArgs e)
        {

            string updateZadatelID = "48";
            string updateKontaktniOsobaID = "19";

            // Pokud má tlačítko text "Upravit", vyvolá metodu upravit záznam
            if (btnOdeslat.Text == "Upravit")
            {
                Methods method;
                method = new Methods();

                bool pokracovat = VyplnenaPole();

                if (pokracovat == true)
                {
                    Connect newConnection;
                    newConnection = new Connect();
                    newConnection.Connection();

                    int prohlaseni = 0;
                    if (rbtProhlaseniAno.Checked)
                    {
                        prohlaseni = 1;
                    }
                    else if (rbtProhlaseniNe.Checked)
                    {
                        prohlaseni = 0;
                    }
                    int vyuzivatSluzebCharity = 0;
                    if (rbtVyuzivateSluzebCharityAno.Checked)
                    {
                        vyuzivatSluzebCharity = 1;
                    }
                    else if (rbtVyuzivateSluzebCharityNe.Checked)
                    {
                        vyuzivatSluzebCharity = 0;
                    }
                    int plneSobestacny = 0;
                    if (rbtPlneSobestacnyAno.Checked)
                    {
                        plneSobestacny = 1;
                    }
                    else if (rbtPlneSobestacnyNe.Checked)
                    {
                        plneSobestacny = 0;
                    }
                    int pohybovePotize = 0;
                    if (rbtPohybovePotizeAno.Checked)
                    {
                        pohybovePotize = 1;
                    }
                    else if (rbtPohybovePotizeNe.Checked)
                    {
                        pohybovePotize = 0;
                    }

                    //int ulozeno = 0;

                    try
                    {
                            method.UdajeUPDATE(txbJmeno.Text, txbPrijmeni.Text, txbMistoNarozeni.Text, dtpDatumNarozeni.Value.ToLongDateString(), txbRodneCislo.Text, txbAbsolvovanaZamestnani.Text, txbRodinnyStav.Text, txbTelCislo.Text, txbVzdelani.Text,
                            txaPoznamka.Text, prohlaseni, txaJineZdravotniPotize.Text, plneSobestacny, pohybovePotize, vyuzivatSluzebCharity, txbKontaktniOsobaJmeno.Text, txbKontaktniOsobaPrijmeni.Text,
                            txbKontaktniOsobaTelCislo.Text, updateZadatelID, updateKontaktniOsobaID);

                        MessageBox.Show("Žadatel byl uložen do databáze.");
                        CloseForm();

                    }
                    catch(Exception ex)
                    {
                        MessageBox.Show(ex.ToString());
                    }
                    
                }

            }
            else
            {
                Methods method;
                method = new Methods();

                bool pokracovat = VyplnenaPole();

                // Pokud jsou všechna pole vyplněná správně
                if (pokracovat == true)
                {
                    // Inicializace připojení k databázi pomocí externí třídy Connect
                    Connect newConnection;
                    newConnection = new Connect();
                    newConnection.Connection();

                    SqlParameter returnParameterData = new SqlParameter();

                    // Použití metody ZadatelINSERT, která uloží data do tabulky dbo.Zadatel a vrací zpětnou hodnozu zadatelID
                    int zadatelID = method.ZadatelINSERT(dtpDatumNarozeni.Value.ToLongDateString(), txbJmeno.Text, txbMistoNarozeni.Text, txbPrijmeni.Text, txbRodneCislo.Text);

                    method.DoplnujiciUdajeINSERT(txbAbsolvovanaZamestnani.Text, txbRodinnyStav.Text, txbTelCislo.Text, txbVzdelani.Text, zadatelID);

                    int prohlaseni = 0;
                    if (rbtProhlaseniAno.Checked)
                    {
                        prohlaseni = 1;
                    }
                    else if (rbtProhlaseniNe.Checked)
                    {
                        prohlaseni = 0;
                    }
                    method.PoznamkaINSERT(txaPoznamka.Text, prohlaseni, zadatelID);

                    int kontaktniOsobaID = method.KontaktniOsobaINSERT(txbKontaktniOsobaJmeno.Text, txbKontaktniOsobaPrijmeni.Text, txbKontaktniOsobaTelCislo.Text, zadatelID);

                    method.ZadavatelKontaktniOsobaINSERT(kontaktniOsobaID, zadatelID);

                    int vyuzivatSluzebCharity = 0;
                    if (rbtVyuzivateSluzebCharityAno.Checked)
                    {
                        vyuzivatSluzebCharity = 1;
                    }
                    else if (rbtVyuzivateSluzebCharityNe.Checked)
                    {
                        vyuzivatSluzebCharity = 0;
                    }
                    int plneSobestacny = 0;
                    if (rbtPlneSobestacnyAno.Checked)
                    {
                        plneSobestacny = 1;
                    }
                    else if (rbtPlneSobestacnyNe.Checked)
                    {
                        plneSobestacny = 0;
                    }
                    int pohybovePotize = 0;
                    if (rbtPohybovePotizeAno.Checked)
                    {
                        pohybovePotize = 1;
                    }
                    else if (rbtPohybovePotizeNe.Checked)
                    {
                        pohybovePotize = 0;
                    }

                    int zdravotniStavID = method.ZdravotniStavINSERT(vyuzivatSluzebCharity, plneSobestacny, pohybovePotize, txaJineZdravotniPotize.Text, zadatelID);

                    MessageBox.Show("Žadatel byl uložen do databáze.");

                    ClearForm();

                }
                else
                {

                }
            }
        }

        // Funkce schovávající Textové pole txaJineZravotniPotize
        private void rbtJineZdravotniPotizeNe_CheckedChanged(object sender, EventArgs e)
        {         
            txaJineZdravotniPotize.Hide();
        }
        
        private void gbxJineZdravotniPotize_Enter(object sender, EventArgs e)
        {

        }

        // Funkce zobrazující Textové pole txaJineZravotniPotize
        private void rbtJineZdravotniPotizeAno_CheckedChanged(object sender, EventArgs e)
        {                                               
            txaJineZdravotniPotize.Show();
        }

        // Funkce ověřující jestli jsou vstupní pole vyplněná
        private bool VyplnenaPole()
        {

            // deklarace proměnné pokračovat
            bool pokracovat = true;
            string hlaska = "";
            
            // Ověření vyplnění pole txbJmeno 
            if(txbJmeno.Text == "")
            {
                pokracovat = false;
                hlaska = hlaska + "Vyplňte jméno žadatele!!\r";
            }

            // Ověření vyplnění pole txbPrijmeni 
            if (txbPrijmeni.Text == "")
            {
                pokracovat = false;
                hlaska = hlaska + "Vyplňte příjmení žadatele!!\r";
            }

            // Ověření vyplnění pole txbMistoNarozeni 
            if (txbMistoNarozeni.Text == "")
            {
                pokracovat = false;
                hlaska = hlaska + "Vyplňte místo narození žadatele!!\r";
            }

            // Ověření správného vyplnění pole txbRodneCislo 
            if (txbRodneCislo.Text == "" || (System.Text.RegularExpressions.Regex.IsMatch(txbRodneCislo.Text, "[^0-9]"+"/")))
            {
                pokracovat = false;
                hlaska = hlaska + "Vyplňte správně rodné číslo Žadatele!!\r";
            }

            // Ověření vyplnění pole txbAbsolvovanaZamestnani
            if (txbAbsolvovanaZamestnani.Text == "")
            {
                pokracovat = false;
                hlaska = hlaska + "Vyplňte absolvovaná zaměstnání Žadatele!!\r";
            }

            // Ověření vyplnění pole txbRodinnyStav
            if (txbRodinnyStav.Text == "")
            {
                pokracovat = false;
                hlaska = hlaska + "Vyplňte rodinný stav Žadatele!!\r";
            }

            // Ověření vyplnění pole txbTelefonnicislo
            if (txbTelCislo.Text == "" || (System.Text.RegularExpressions.Regex.IsMatch(txbTelCislo.Text, "[^0-9]" + "+")))
            {
                pokracovat = false;
                hlaska = hlaska + "Vyplňte správně telefonní číslo Žadatele!!\r";
            }

            // Ověření vyplnění pole txbVzdelani
            if (txbVzdelani.Text == "")
            {
                pokracovat = false;
                hlaska = hlaska + "Vyplňte vzdělání Žadatele!!\r";
            }

            // Ověření vyplnění pole txbKontaktniOsobaJmeno
            if (txbKontaktniOsobaJmeno.Text == "")
            {
                pokracovat = false;
                hlaska = hlaska + "Vyplňte jméno kontaktní osoby!!\r";
            }

            // Ověření vyplnění pole txbKontaktniOsobaPrijmeni
            if (txbKontaktniOsobaPrijmeni.Text == "")
            {
                pokracovat = false;
                hlaska = hlaska + "Vyplňte přijmení kontaktní osoby!!\r";
            }

            // Ověření vyplnění pole txbKontaktniOsobaTelCislo
            if (txbKontaktniOsobaTelCislo.Text == "")
            {
                pokracovat = false;
                hlaska = hlaska + "Vyplňte telefonní číslo kontaktní osoby!!\r";
            }

            // Ověření vyplnění zaškrtnutí rbtProhlaseniAno
            if (rbtProhlaseniNe.Checked)
            {
                pokracovat = false;
                hlaska = hlaska + "Vyplňte telefonní číslo kontaktní osoby!!\r";
            }

            if(pokracovat == false)
            {
                ChybovaHlaska(hlaska);
            }

            return pokracovat;
        }

        // Funkce pro vyčištění formuláře po odeslání
        private void ClearForm()
        {
            DatovyFormular NovyDatovyFormular = new DatovyFormular();
            NovyDatovyFormular.Show();
            this.Dispose(false);
        }

        // Chybová hláška
        private void ChybovaHlaska(string hlaska)
        {
            MessageBox.Show(hlaska);
        }

        private void CloseForm()
        {
            this.Close();
        }

    }
}
