﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data.Sql;
using System.Data.SqlClient;
using System.Data;
using System.Windows.Forms;
using System.IO;

namespace PseudonymizaceDat
{
    class Methods
    {
        // Metoda ukládající údaje žadatele do databáze
        public int ZadatelINSERT(string datumNarozeni, string jmeno, string mistoNarozeni, string prijmeni, string rodneCislo)
        {
            Connect newConnection;
            newConnection = new Connect();
            newConnection.Connection();

            SqlParameter returnParameterData = new SqlParameter();

            SqlCommand zadatelINSERT = new SqlCommand("INSERT_Zadatel", newConnection.Connection());
            zadatelINSERT.Parameters.Add("@datumNarozeni", SqlDbType.VarChar).Value = datumNarozeni;
            zadatelINSERT.Parameters.Add("@jmeno", SqlDbType.VarChar).Value = jmeno;
            zadatelINSERT.Parameters.Add("@mistoNarozeni", SqlDbType.VarChar).Value = mistoNarozeni;
            zadatelINSERT.Parameters.Add("@prijmeni", SqlDbType.VarChar).Value = prijmeni;
            zadatelINSERT.Parameters.Add("@rodneCislo", SqlDbType.VarChar).Value = rodneCislo;
            zadatelINSERT.CommandType = CommandType.StoredProcedure;
            var returnValue = (System.Int32)zadatelINSERT.ExecuteScalar();

            int ZadatelID = returnValue;

            return ZadatelID;

        }
        // Metoda ukládající doplňující údaje do databáze
        public int DoplnujiciUdajeINSERT(string absolvovanaZamestnani, string rodinnyStav, string telcislo, string vzdelani, int zadatelID)
        {
            Connect newConnection;
            newConnection = new Connect();
            newConnection.Connection();

            SqlParameter returnParameterData = new SqlParameter();

            SqlCommand datumNarozeniCommand = new SqlCommand("SELECT Convert(varchar(100), DECRYPTBYPASSPHRASE('tdi202', DatumNarozeni)) AS DatumNarozeni FROM Zadatel Where ZadatelID = " + zadatelID, newConnection.Connection());
            string datumNarozeniString = (string)datumNarozeniCommand.ExecuteScalar();
            DateTime datumNarozeni = DateTime.Parse(datumNarozeniString);   
            DateTime aktualniDatum = DateTime.Today;

            DateTime zeroTime = new DateTime(1, 1, 1);
            TimeSpan age = aktualniDatum - datumNarozeni;
            int vek = (zeroTime + age).Year;

            SqlCommand doplnujiciUdajeINSERT = new SqlCommand("INSERT_Doplnujici_udaje", newConnection.Connection());
            doplnujiciUdajeINSERT.Parameters.Add("@absolvovanaZamestnani", SqlDbType.VarChar).Value = absolvovanaZamestnani;
            doplnujiciUdajeINSERT.Parameters.Add("@rodinnyStav", SqlDbType.VarChar).Value = rodinnyStav;
            doplnujiciUdajeINSERT.Parameters.Add("@telCislo", SqlDbType.VarChar).Value = telcislo;
            doplnujiciUdajeINSERT.Parameters.Add("@vek", SqlDbType.VarChar).Value = vek;
            doplnujiciUdajeINSERT.Parameters.Add("@vzdelani", SqlDbType.VarChar).Value = vzdelani;
            doplnujiciUdajeINSERT.Parameters.Add("@zadatelID", SqlDbType.VarChar).Value = zadatelID;
            doplnujiciUdajeINSERT.CommandType = CommandType.StoredProcedure;
            var returnValue = (System.Int32)doplnujiciUdajeINSERT.ExecuteScalar();

            int doplnujiciUdajelID = returnValue;

            return doplnujiciUdajelID;
        }

        // Metoda ukládající údaje poznámky do databáze
        public int PoznamkaINSERT(string poznamka, int prohlaseni, int zadatelID)
        {
            Connect newConnection;
            newConnection = new Connect();
            newConnection.Connection();

            SqlParameter returnParameterData = new SqlParameter();

            SqlCommand poznamkaINSERT = new SqlCommand("INSERT_Poznamka", newConnection.Connection());
            poznamkaINSERT.Parameters.Add("@poznamka", SqlDbType.VarChar).Value = poznamka;
            poznamkaINSERT.Parameters.Add("@prohlaseni", SqlDbType.VarChar).Value = prohlaseni;
            poznamkaINSERT.Parameters.Add("@zadatelID", SqlDbType.VarChar).Value = zadatelID;
            poznamkaINSERT.CommandType = CommandType.StoredProcedure;
            var returnValue = (System.Int32)poznamkaINSERT.ExecuteScalar();

            int poznamkaID = returnValue;

            return poznamkaID;
        }

        // Metoda ukládající údaje kontaktní osoby do databáze
        public int KontaktniOsobaINSERT(string jmeno, string prijmeni, string telCislo, int zadatelID)
        {
            Connect newConnection;
            newConnection = new Connect();
            newConnection.Connection();

            SqlParameter returnParameterData = new SqlParameter();

            SqlCommand kontaktniOsobaINSERT = new SqlCommand("INSERT_Kontaktni_osoba", newConnection.Connection());
            kontaktniOsobaINSERT.Parameters.Add("@jmeno", SqlDbType.VarChar).Value = jmeno;
            kontaktniOsobaINSERT.Parameters.Add("@prijmeni", SqlDbType.VarChar).Value = prijmeni;
            kontaktniOsobaINSERT.Parameters.Add("@telCislo", SqlDbType.VarChar).Value = telCislo;
            kontaktniOsobaINSERT.CommandType = CommandType.StoredProcedure;
            var returnValue = (System.Int32)kontaktniOsobaINSERT.ExecuteScalar();

            int kontaktniOsobaID = returnValue;

            return kontaktniOsobaID;
        }
        // Metoda ukládající údaje do propojovací tabulky v databázi
        public void ZadavatelKontaktniOsobaINSERT(int kontaktniOsobaID, int zadatelID)
        {
            Connect newConnection;
            newConnection = new Connect();
            newConnection.Connection();

            SqlParameter returnParameterData = new SqlParameter();

            SqlCommand zadavatelKontaktniOsobaINSERT = new SqlCommand("INSERT_ZADATEL_KONTAKTNI_OSOBA", newConnection.Connection());
            zadavatelKontaktniOsobaINSERT.Parameters.Add("@kontaktniOsobaID", SqlDbType.VarChar).Value = kontaktniOsobaID;
            zadavatelKontaktniOsobaINSERT.Parameters.Add("@zadatelID", SqlDbType.VarChar).Value = zadatelID;
            zadavatelKontaktniOsobaINSERT.CommandType = CommandType.StoredProcedure;
            zadavatelKontaktniOsobaINSERT.ExecuteNonQuery();
        }

        // Metoda ukládající údaje zdravotního stavu do databáze
        public int ZdravotniStavINSERT(int vyuzivatSluzebCharity, int plneSobestacny, int pohybovePotize, string jineZdravotniPotize, int zadatelID)
        {
            Connect newConnection;
            newConnection = new Connect();
            newConnection.Connection();

            SqlParameter returnParameterData = new SqlParameter();

            SqlCommand zdravotniStavINSERT = new SqlCommand("INSERT_Zdravotni_stav", newConnection.Connection());
            zdravotniStavINSERT.Parameters.Add("@jineZdravotniPotize", SqlDbType.VarChar).Value = jineZdravotniPotize;
            zdravotniStavINSERT.Parameters.Add("@plneSobestacny", SqlDbType.VarChar).Value = plneSobestacny;
            zdravotniStavINSERT.Parameters.Add("@pohybovePotize", SqlDbType.VarChar).Value = pohybovePotize;
            zdravotniStavINSERT.Parameters.Add("@vyuzivatSluzebCharity", SqlDbType.VarChar).Value = vyuzivatSluzebCharity;
            zdravotniStavINSERT.Parameters.Add("@zadatelID", SqlDbType.VarChar).Value = zadatelID;
            zdravotniStavINSERT.CommandType = CommandType.StoredProcedure;
            var returnValue = (System.Int32)zdravotniStavINSERT.ExecuteScalar();

            int zdravotniStavID = returnValue;

            return zdravotniStavID;
        }

        // Metoda vypisující údaje z tabulky zadatel
        public string[,] ZadatelSELECT(string datumNarozeni, string jmeno, string mistoNarozeni, string prijmeni, string rodneCislo, string zadatelID)
        {
            string[] dataSQL = null;
            int rowCount = 0;
            int columnCount = 0;

            Connect newConnection;
            newConnection = new Connect();
            newConnection.Connection();

            SqlParameter returnParameterData = new SqlParameter();

            SqlCommand zadatelSELECT = new SqlCommand("SELECT_Zadatel", newConnection.Connection());
            zadatelSELECT.Parameters.Add("@datumNarozeni", SqlDbType.VarChar).Value = datumNarozeni;
            zadatelSELECT.Parameters.Add("@jmeno", SqlDbType.VarChar).Value = jmeno;
            zadatelSELECT.Parameters.Add("@mistoNarozeni", SqlDbType.VarChar).Value = mistoNarozeni;
            zadatelSELECT.Parameters.Add("@prijmeni", SqlDbType.VarChar).Value = prijmeni;
            zadatelSELECT.Parameters.Add("@rodneCislo", SqlDbType.VarChar).Value = rodneCislo;
            zadatelSELECT.Parameters.Add("@zadatelID", SqlDbType.VarChar).Value = zadatelID;
            zadatelSELECT.CommandType = CommandType.StoredProcedure;

            SqlParameter returnParameter = zadatelSELECT.Parameters.Add("RetVal", SqlDbType.Int);
            returnParameter.Direction = ParameterDirection.ReturnValue;
            zadatelSELECT.ExecuteNonQuery();

            SqlDataReader reader = zadatelSELECT.ExecuteReader();

            rowCount = (int)returnParameter.Value;
            columnCount = reader.FieldCount;

            string[,] returnValue = new string[rowCount,columnCount];
            int pomRadek = 0;
            int pomSloupec = 0;

            while (reader.Read())
            {
                
                dataSQL = ReadSingleRow((IDataRecord)reader);

                while (pomSloupec < columnCount)
                {
                    returnValue[pomRadek, pomSloupec] = dataSQL[pomSloupec];
                    pomSloupec++;
                }
                pomSloupec = 0;
                pomRadek++;
                
            }

            return returnValue;
           
        }

        // Metoda vypisující údaje z tabulky doplnujiciUdaje
        public string[,] DoplnujiciUdajeSELECT(string zadatelID, string doplnujiciUdajeID, string vzdelani, string vek, string telCislo, string rodinnyStav, string absolvovanaZamestnani)
        {
            string[] dataSQL = null;
            int rowCount = 0;
            int columnCount = 0;

            Connect newConnection;
            newConnection = new Connect();
            newConnection.Connection();

            SqlParameter returnParameterData = new SqlParameter();

            SqlCommand doplnujiciUdajeSELECT = new SqlCommand("SELECT_Doplnujici_udaje", newConnection.Connection());
            doplnujiciUdajeSELECT.Parameters.Add("@doplnujiciUdajeID", SqlDbType.VarChar).Value = doplnujiciUdajeID;
            doplnujiciUdajeSELECT.Parameters.Add("@vzdelani", SqlDbType.VarChar).Value = vzdelani;
            doplnujiciUdajeSELECT.Parameters.Add("@vek", SqlDbType.VarChar).Value = vek;
            doplnujiciUdajeSELECT.Parameters.Add("@telCislo", SqlDbType.VarChar).Value = telCislo;
            doplnujiciUdajeSELECT.Parameters.Add("@rodinnyStav", SqlDbType.VarChar).Value = rodinnyStav;
            doplnujiciUdajeSELECT.Parameters.Add("@zadatelID", SqlDbType.VarChar).Value = zadatelID;
            doplnujiciUdajeSELECT.CommandType = CommandType.StoredProcedure;

            SqlParameter returnParameter = doplnujiciUdajeSELECT.Parameters.Add("RetVal", SqlDbType.Int);
            returnParameter.Direction = ParameterDirection.ReturnValue;
            doplnujiciUdajeSELECT.ExecuteNonQuery();

            SqlDataReader reader = doplnujiciUdajeSELECT.ExecuteReader();

            rowCount = (int)returnParameter.Value;
            columnCount = reader.FieldCount;

            string[,] returnValue = new string[rowCount, columnCount];
            int pomRadek = 0;
            int pomSloupec = 0;

            while (reader.Read())
            {

                dataSQL = ReadSingleRow((IDataRecord)reader);

                while (pomSloupec < columnCount)
                {
                    returnValue[pomRadek, pomSloupec] = dataSQL[pomSloupec];
                    pomSloupec++;
                }
                pomSloupec = 0;
                pomRadek++;

            }

            return returnValue;
        }

        // Metoda vypisující údaje z tabulky zdravotniStav
        public string[,] ZdravotniStavSELECT(string jineZdravotniPotize, string plneSobestacny, string pohybovePotize, string vyuzivatSluzebCharity, string zadatelID, string zdravotniStavID)
        {
            string[] dataSQL = null;
            int rowCount = 0;
            int columnCount = 0;

            Connect newConnection;
            newConnection = new Connect();
            newConnection.Connection();

            SqlParameter returnParameterData = new SqlParameter();

            SqlCommand doplnujiciUdajeSELECT = new SqlCommand("SELECT_Zdravotni_stav", newConnection.Connection());
            doplnujiciUdajeSELECT.Parameters.Add("@jineZdravotniPotize", SqlDbType.VarChar).Value = jineZdravotniPotize;
            doplnujiciUdajeSELECT.Parameters.Add("@plneSobestacny", SqlDbType.VarChar).Value = plneSobestacny;
            doplnujiciUdajeSELECT.Parameters.Add("@pohybovePotize", SqlDbType.VarChar).Value = pohybovePotize;
            doplnujiciUdajeSELECT.Parameters.Add("@vyuzivatSluzebCharity", SqlDbType.VarChar).Value = vyuzivatSluzebCharity;
            doplnujiciUdajeSELECT.Parameters.Add("@zadatelID", SqlDbType.VarChar).Value = zadatelID;
            doplnujiciUdajeSELECT.Parameters.Add("@zdravotniStavID", SqlDbType.VarChar).Value = zdravotniStavID;
            doplnujiciUdajeSELECT.CommandType = CommandType.StoredProcedure;

            SqlParameter returnParameter = doplnujiciUdajeSELECT.Parameters.Add("RetVal", SqlDbType.Int);
            returnParameter.Direction = ParameterDirection.ReturnValue;
            doplnujiciUdajeSELECT.ExecuteNonQuery();

            SqlDataReader reader = doplnujiciUdajeSELECT.ExecuteReader();

            rowCount = (int)returnParameter.Value;
            columnCount = reader.FieldCount;

            string[,] returnValue = new string[rowCount, columnCount];
            int pomRadek = 0;
            int pomSloupec = 0;

            while (reader.Read())
            {

                dataSQL = ReadSingleRow((IDataRecord)reader);

                while (pomSloupec < columnCount)
                {
                    returnValue[pomRadek, pomSloupec] = dataSQL[pomSloupec];
                    pomSloupec++;
                }
                pomSloupec = 0;
                pomRadek++;

            }

            return returnValue;
        }

        // Metoda vypisující údaje z tabulky ZADATEL_KONTAKTNI_OSOBA
        public string[,] ZadatelKontaktniOsobaSELECT(string kontaktniOsobaID, string zadatelID)
        {
            string[] dataSQL = null;
            int rowCount = 0;
            int columnCount = 0;

            Connect newConnection;
            newConnection = new Connect();
            newConnection.Connection();

            SqlParameter returnParameterData = new SqlParameter();

            SqlCommand zadatelKontaktniOsobaSELECT = new SqlCommand("SELECT_ZADATEL_KONTAKTNI_OSOBA", newConnection.Connection());
            zadatelKontaktniOsobaSELECT.Parameters.Add("@kontaktni_osobaID", SqlDbType.VarChar).Value = kontaktniOsobaID;
            zadatelKontaktniOsobaSELECT.Parameters.Add("@zadatelID", SqlDbType.VarChar).Value = zadatelID;
            zadatelKontaktniOsobaSELECT.CommandType = CommandType.StoredProcedure;

            SqlParameter returnParameter = zadatelKontaktniOsobaSELECT.Parameters.Add("RetVal", SqlDbType.Int);
            returnParameter.Direction = ParameterDirection.ReturnValue;
            zadatelKontaktniOsobaSELECT.ExecuteNonQuery();

            SqlDataReader reader = zadatelKontaktniOsobaSELECT.ExecuteReader();

            rowCount = (int)returnParameter.Value;
            columnCount = reader.FieldCount;

            string[,] returnValue = new string[rowCount, columnCount];
            int pomRadek = 0;
            int pomSloupec = 0;

            while (reader.Read())
            {

                dataSQL = ReadSingleRow((IDataRecord)reader);

                while (pomSloupec < columnCount)
                {
                    returnValue[pomRadek, pomSloupec] = dataSQL[pomSloupec];
                    pomSloupec++;
                }
                pomSloupec = 0;
                pomRadek++;

            }

            return returnValue;
        }

        // Metoda vypisující údaje z tabulky KontakntiOsoba
        public string[,] KontaktniOsobaSELECT(string jmeno, string prijmeni, string telCislo, string kontaktniUdajeID)
        {
            string[] dataSQL = null;
            int rowCount = 0;
            int columnCount = 0;

            Connect newConnection;
            newConnection = new Connect();
            newConnection.Connection();

            SqlParameter returnParameterData = new SqlParameter();

            SqlCommand kontaktniOsobaSELECT = new SqlCommand("SELECT_Kontaktni_osoba", newConnection.Connection());
            kontaktniOsobaSELECT.Parameters.Add("@jmeno", SqlDbType.VarChar).Value = jmeno;
            kontaktniOsobaSELECT.Parameters.Add("@prijmeni", SqlDbType.VarChar).Value = prijmeni;
            kontaktniOsobaSELECT.Parameters.Add("@telCislo", SqlDbType.VarChar).Value = telCislo;
            kontaktniOsobaSELECT.Parameters.Add("@kontaktni_udajeID", SqlDbType.VarChar).Value = kontaktniUdajeID;
            kontaktniOsobaSELECT.CommandType = CommandType.StoredProcedure;

            SqlParameter returnParameter = kontaktniOsobaSELECT.Parameters.Add("RetVal", SqlDbType.Int);
            returnParameter.Direction = ParameterDirection.ReturnValue;
            kontaktniOsobaSELECT.ExecuteNonQuery();

            SqlDataReader reader = kontaktniOsobaSELECT.ExecuteReader();

            rowCount = (int)returnParameter.Value;
            columnCount = reader.FieldCount;

            string[,] returnValue = new string[rowCount, columnCount];
            int pomRadek = 0;
            int pomSloupec = 0;

            while (reader.Read())
            {

                dataSQL = ReadSingleRow((IDataRecord)reader);

                while (pomSloupec < columnCount)
                {
                    returnValue[pomRadek, pomSloupec] = dataSQL[pomSloupec];
                    pomSloupec++;
                }
                pomSloupec = 0;
                pomRadek++;

            }

            return returnValue;
        }

        // Metoda vypisující údaje z tabulky Poznamka
        public string[,] PoznamkaSELECT(string poznamka,  string prohlaseni, string poznamkaID, string zadatelID)
        {
            string[] dataSQL = null;
            int rowCount = 0;
            int columnCount = 0;

            Connect newConnection;
            newConnection = new Connect();
            newConnection.Connection();

            SqlParameter returnParameterData = new SqlParameter();

            SqlCommand poznamkaSELECT = new SqlCommand("SELECT_Poznamka", newConnection.Connection());
            poznamkaSELECT.Parameters.Add("@poznamka", SqlDbType.VarChar).Value = poznamka;
            poznamkaSELECT.Parameters.Add("@prohlaseni", SqlDbType.VarChar).Value = prohlaseni;
            poznamkaSELECT.Parameters.Add("@poznamkaID", SqlDbType.VarChar).Value = poznamkaID;
            poznamkaSELECT.Parameters.Add("@zadatelID", SqlDbType.VarChar).Value = zadatelID;
            poznamkaSELECT.CommandType = CommandType.StoredProcedure;

            SqlParameter returnParameter = poznamkaSELECT.Parameters.Add("RetVal", SqlDbType.Int);
            returnParameter.Direction = ParameterDirection.ReturnValue;
            poznamkaSELECT.ExecuteNonQuery();

            SqlDataReader reader = poznamkaSELECT.ExecuteReader();

            rowCount = (int)returnParameter.Value;
            columnCount = reader.FieldCount;

            string[,] returnValue = new string[rowCount, columnCount];
            int pomRadek = 0;
            int pomSloupec = 0;

            while (reader.Read())
            {

                dataSQL = ReadSingleRow((IDataRecord)reader);

                while (pomSloupec < columnCount)
                {
                    returnValue[pomRadek, pomSloupec] = dataSQL[pomSloupec];
                    pomSloupec++;
                }
                pomSloupec = 0;
                pomRadek++;
            }

            return returnValue;
        }

        // Metoda upravující záznamy v tabulce
        public void UdajeUPDATE(
                               string jmeno, string prijmeni, string mistoNarozeni, string datumNarozeniString, string rodneCislo, 
                               string absolvovanaZamestnani, string rodinnyStav, string telCislo, string vzdelani,
                               string poznamka, int prohlaseni, string jineZdravotniPotize, int plneSobestacny, int pohybovePotize,
                               int vyuzivateluzebCharity, string jmenoKontaktniOsoba, string prijmeniKontaktniOsoba, string telCisloKontaktniOsoba,
                               string zadatelID, string kontaktniOsobaID
                              )
        {
            Connect newConnection;
            newConnection = new Connect();
            newConnection.Connection();

            SqlParameter returnParameterData = new SqlParameter();

            DateTime datumNarozeni = DateTime.Parse(datumNarozeniString);
            DateTime aktualniDatum = DateTime.Today;

            DateTime zeroTime = new DateTime(1, 1, 1);
            TimeSpan age = aktualniDatum - datumNarozeni;
            int vek = (zeroTime + age).Year;

            SqlCommand udajeUPDATE = new SqlCommand("UPDATE_Vsechny_udaje", newConnection.Connection());
            udajeUPDATE.Parameters.Add("@jmeno", SqlDbType.VarChar).Value = jmeno;
            udajeUPDATE.Parameters.Add("@prijmeni", SqlDbType.VarChar).Value = prijmeni;
            udajeUPDATE.Parameters.Add("@mistoNarozeni", SqlDbType.VarChar).Value = mistoNarozeni;
            udajeUPDATE.Parameters.Add("@datumNarozeni", SqlDbType.VarChar).Value = datumNarozeni;
            udajeUPDATE.Parameters.Add("@rodneCislo", SqlDbType.VarChar).Value = rodneCislo;
            udajeUPDATE.Parameters.Add("@absolvovanaZamestnani", SqlDbType.VarChar).Value = absolvovanaZamestnani;
            udajeUPDATE.Parameters.Add("@rodinnyStav", SqlDbType.VarChar).Value = rodinnyStav;
            udajeUPDATE.Parameters.Add("@telCislo", SqlDbType.VarChar).Value = telCislo;
            udajeUPDATE.Parameters.Add("@vek", SqlDbType.VarChar).Value = vek;
            udajeUPDATE.Parameters.Add("@vzdelani", SqlDbType.VarChar).Value = vzdelani;
            udajeUPDATE.Parameters.Add("@poznamka", SqlDbType.VarChar).Value = poznamka;
            udajeUPDATE.Parameters.Add("@prohlaseni", SqlDbType.VarChar).Value = prohlaseni;
            udajeUPDATE.Parameters.Add("@jineZdravotniPotize", SqlDbType.VarChar).Value = jineZdravotniPotize;
            udajeUPDATE.Parameters.Add("@plneSobestacny", SqlDbType.VarChar).Value = plneSobestacny;
            udajeUPDATE.Parameters.Add("@pohybovePotize", SqlDbType.VarChar).Value = pohybovePotize;
            udajeUPDATE.Parameters.Add("@vyuzivatSluzebCharity", SqlDbType.VarChar).Value = vyuzivateluzebCharity;
            udajeUPDATE.Parameters.Add("@jmenoKontaktniOsoba", SqlDbType.VarChar).Value = jmenoKontaktniOsoba;
            udajeUPDATE.Parameters.Add("@prijmeniKontaktniOsoba", SqlDbType.VarChar).Value = prijmeniKontaktniOsoba;
            udajeUPDATE.Parameters.Add("@telCisloKontaktniOsoba", SqlDbType.VarChar).Value = telCisloKontaktniOsoba;
            udajeUPDATE.Parameters.Add("@zadatelID", SqlDbType.VarChar).Value = zadatelID;
            udajeUPDATE.Parameters.Add("@kontaktniOsobaID", SqlDbType.VarChar).Value = kontaktniOsobaID;
            udajeUPDATE.CommandType = CommandType.StoredProcedure;
            udajeUPDATE.ExecuteNonQuery();

        }


        // Metoda volající proceduru smazat řádek
        public void DELETE_Radek(string zadatelID)
        {
            Connect newConnection;
            newConnection = new Connect();
            newConnection.Connection();

            SqlParameter returnParameterData = new SqlParameter();

            SqlCommand radekDELETE = new SqlCommand("DELETE_Radek", newConnection.Connection());
            radekDELETE.Parameters.Add("@zadatelID", SqlDbType.VarChar).Value = zadatelID;
            radekDELETE.CommandType = CommandType.StoredProcedure;
            radekDELETE.ExecuteNonQuery();
        }

        // Metoda čte údaje z řádku v listView
        private static string[] ReadSingleRow(IDataRecord record)
        {
            int pocetSloupcu = record.FieldCount;
            int pom = 0;

            string[] dataSQL = new string[pocetSloupcu];

            while(pom < pocetSloupcu)
            {
                dataSQL[pom] = String.Format("{0}", record[pom]);
                pom++;
            }

            return dataSQL;
        }

        // Funkce exportující údaje z listView do csv souboru
        public static void ListViewToCSV(ListView listView, string filePath, bool includeHidden)
        {
            //make header string
            StringBuilder result = new StringBuilder();
            WriteCSVRow(result, listView.Columns.Count, i => includeHidden || listView.Columns[i].Width > 0, i => listView.Columns[i].Text);

            //export data rows
            foreach (ListViewItem listItem in listView.Items)
                WriteCSVRow(result, listView.Columns.Count, i => includeHidden || listView.Columns[i].Width > 0, i => listItem.SubItems[i].Text);

            File.WriteAllText(filePath, result.ToString(), Encoding.Unicode);
        }

        // Funkce zapisující do jednoho řádku csv souboru
        private static void WriteCSVRow(StringBuilder result, int itemsCount, Func<int, bool> isColumnNeeded, Func<int, string> columnValue)
        {
            bool isFirstTime = true;
            for (int i = 0; i < itemsCount; i++)
            {
                if (!isColumnNeeded(i))
                    continue;

                if (!isFirstTime)
                    result.Append(",");
                isFirstTime = false;

                result.Append(String.Format("\"{0}\"", columnValue(i)));
            }
            result.AppendLine();
        }

        public bool Autentification(string login, string heslo)
        {
            bool overenyUzivatel = false;

            if(login == "admin" && heslo == "admin")
            {
                overenyUzivatel = true;
            }

            return overenyUzivatel; 
        }

    }
}
